package fxKaljoja;

import fi.jyu.mit.fxgui.Dialogs;

import fi.jyu.mit.fxgui.DynamicComboBox;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.*;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;
import Luokat.*;


/**
 * @author miikk
 * @version 29.1.2025
 *
 */
public class KalojaGUIController implements Initializable, ModalControllerInterface<List<Saalis>> {
	@FXML private ComboBox<String> koko;

	@FXML private DynamicComboBox lajit;

	@FXML private TextField vieheVarit;

	@FXML private DynamicComboBox vieheet;

	private List<Saalis> saalis ;
	
   @Override
   public void initialize(URL url, ResourceBundle resourceBundle){
		koko.setItems(FXCollections.observableArrayList("Sintti", "Keskikokoinen", "Iso", "Kalavalhe"));
   }

   



	 @FXML private void handlePoista(){
		 Poista();
	 }

	 private void Poista() {
		 Dialogs.showMessageDialog("poistutaan! Mutta ei toimi vielä");
	 }

	@FXML private void handleTallenna() {
		Tallenna();
	}

	 private void Tallenna() {

	   Saalis s = new Saalis(koko.getSelectionModel().getSelectedItem(), lajit.getSelectionModel().getSelectedItem());
	   saalis.add(s);
	   System.out.println("saalis : koko " + s.getKoko() + " laji " + s.getLaji() + " id " + s.getSaaliinId() + " Reissulta " + s.getReissunTagi());
	   Viehe v  = new Viehe(s.getSaaliinId(), vieheet.getSelectionModel().getSelectedItem(), vieheVarit.getText());
	   System.out.println("saatu vieheellä " + v.getTypyppi() + " " + v.getVari());
	   String tiedot = s.tiedotTallenusMuodossa();
	   System.out.println("Tiedot tallennetaan muodossa: " + tiedot);
	   Saalis s2 = new Saalis(tiedot);
	   System.out.println("saalis muutettuna tiedoista: koko " + s2.getKoko() + " laji " + s2.getLaji() + " id " + s2.getSaaliinId() + " Reissulta " + s2.getReissunTagi());
		 ModalController.closeStage(koko);
	 }
	

	@Override
	public List<Saalis> getResult() {
		return new ArrayList<>();
	}

	@Override
	public void setDefault(List<Saalis> saaliit) {
	   this.saalis = saaliit;

	}

	@Override
	public void handleShown() {
	}
}

